Index: uspace/lib/ui/test/pbutton.c
===================================================================
--- uspace/lib/ui/test/pbutton.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/test/pbutton.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -41,6 +41,8 @@
 PCUT_TEST_SUITE(pbutton);
 
+static errno_t testgc_set_clip_rect(void *, gfx_rect_t *);
 static errno_t testgc_set_color(void *, gfx_color_t *);
 static errno_t testgc_fill_rect(void *, gfx_rect_t *);
+static errno_t testgc_update(void *);
 static errno_t testgc_bitmap_create(void *, gfx_bitmap_params_t *,
     gfx_bitmap_alloc_t *, void **);
@@ -50,6 +52,8 @@
 
 static gfx_context_ops_t ops = {
+	.set_clip_rect = testgc_set_clip_rect,
 	.set_color = testgc_set_color,
 	.fill_rect = testgc_fill_rect,
+	.update = testgc_update,
 	.bitmap_create = testgc_bitmap_create,
 	.bitmap_destroy = testgc_bitmap_destroy,
@@ -178,5 +182,5 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
-	rc = ui_resource_create(gc, &resource);
+	rc = ui_resource_create(gc, false, &resource);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(resource);
@@ -235,5 +239,5 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
-	rc = ui_resource_create(gc, &resource);
+	rc = ui_resource_create(gc, false, &resource);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(resource);
@@ -279,5 +283,5 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
-	rc = ui_resource_create(gc, &resource);
+	rc = ui_resource_create(gc, false, &resource);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(resource);
@@ -328,5 +332,5 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
-	rc = ui_resource_create(gc, &resource);
+	rc = ui_resource_create(gc, false, &resource);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(resource);
@@ -384,5 +388,5 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
-	rc = ui_resource_create(gc, &resource);
+	rc = ui_resource_create(gc, false, &resource);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(resource);
@@ -445,5 +449,5 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
-	rc = ui_resource_create(gc, &resource);
+	rc = ui_resource_create(gc, false, &resource);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(resource);
@@ -488,4 +492,11 @@
 }
 
+static errno_t testgc_set_clip_rect(void *arg, gfx_rect_t *rect)
+{
+	(void) arg;
+	(void) rect;
+	return EOK;
+}
+
 static errno_t testgc_set_color(void *arg, gfx_color_t *color)
 {
@@ -499,4 +510,10 @@
 	(void) arg;
 	(void) rect;
+	return EOK;
+}
+
+static errno_t testgc_update(void *arg)
+{
+	(void) arg;
 	return EOK;
 }
Index: uspace/lib/ui/test/popup.c
===================================================================
--- uspace/lib/ui/test/popup.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/test/popup.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,314 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <gfx/context.h>
+#include <gfx/coord.h>
+#include <gfx/render.h>
+#include <io/kbd_event.h>
+#include <io/pos_event.h>
+#include <mem.h>
+#include <pcut/pcut.h>
+#include <stdbool.h>
+#include <ui/control.h>
+#include <ui/popup.h>
+#include <ui/resource.h>
+#include <ui/ui.h>
+#include <ui/window.h>
+#include "../private/popup.h"
+#include "../private/window.h"
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(popup);
+
+static void test_popup_close(ui_popup_t *, void *);
+static void test_popup_kbd(ui_popup_t *, void *, kbd_event_t *);
+static errno_t test_popup_paint(ui_popup_t *, void *);
+static void test_popup_pos(ui_popup_t *, void *, pos_event_t *);
+
+static ui_popup_cb_t test_popup_cb = {
+	.close = test_popup_close,
+	.kbd = test_popup_kbd,
+	.paint = test_popup_paint,
+	.pos = test_popup_pos,
+};
+
+static ui_popup_cb_t dummy_popup_cb = {
+};
+
+static errno_t test_ctl_paint(void *);
+static ui_evclaim_t test_ctl_pos_event(void *, pos_event_t *);
+static void test_ctl_unfocus(void *);
+
+static ui_control_ops_t test_ctl_ops = {
+	.paint = test_ctl_paint,
+	.pos_event = test_ctl_pos_event,
+	.unfocus = test_ctl_unfocus
+};
+
+typedef struct {
+	errno_t rc;
+	bool close;
+	bool focus;
+	bool kbd;
+	kbd_event_t kbd_event;
+	bool paint;
+	bool pos;
+	pos_event_t pos_event;
+	bool unfocus;
+} test_cb_resp_t;
+
+typedef struct {
+	errno_t rc;
+	ui_evclaim_t claim;
+	bool paint;
+	bool pos;
+	pos_event_t pos_event;
+	bool unfocus;
+} test_ctl_resp_t;
+
+/** Create and destroy popup window */
+PCUT_TEST(create_destroy)
+{
+	errno_t rc;
+	ui_t *ui = NULL;
+	ui_popup_params_t params;
+	ui_popup_t *popup = NULL;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_popup_params_init(&params);
+
+	rc = ui_popup_create(ui, NULL, &params, &popup);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(popup);
+
+	ui_popup_destroy(popup);
+	ui_destroy(ui);
+}
+
+/** ui_popup_destroy() can take NULL argument (no-op) */
+PCUT_TEST(destroy_null)
+{
+	ui_popup_destroy(NULL);
+}
+
+/** ui_popup_add()/ui_popup_remove() ... */
+PCUT_TEST(add_remove)
+{
+	errno_t rc;
+	ui_t *ui = NULL;
+	ui_popup_params_t params;
+	ui_popup_t *popup = NULL;
+	ui_control_t *control = NULL;
+	test_ctl_resp_t resp;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_popup_params_init(&params);
+
+	rc = ui_popup_create(ui, NULL, &params, &popup);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(popup);
+
+	rc = ui_control_new(&test_ctl_ops, &resp, &control);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Control not called since it hasn't been added yet */
+	resp.rc = ENOMEM;
+	resp.paint = false;
+	rc = ui_window_def_paint(popup->window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_FALSE(resp.paint);
+
+	ui_popup_add(popup, control);
+
+	/* Now paint request should be delivered to control */
+	resp.rc = EOK;
+	resp.paint = false;
+	rc = ui_window_def_paint(popup->window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_TRUE(resp.paint);
+
+	ui_popup_remove(popup, control);
+
+	/*
+	 * After having removed the control the request should no longer
+	 * be delivered to it.
+	 */
+	resp.rc = ENOMEM;
+	resp.paint = false;
+	rc = ui_window_def_paint(popup->window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_FALSE(resp.paint);
+
+	ui_popup_destroy(popup);
+	ui_destroy(ui);
+}
+
+/** ui_popup_get_res/gc() return valid objects */
+PCUT_TEST(get_res_gc)
+{
+	errno_t rc;
+	ui_t *ui = NULL;
+	ui_wnd_params_t params;
+	ui_window_t *window = NULL;
+	ui_resource_t *res;
+	gfx_context_t *gc;
+	gfx_rect_t rect;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Hello";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window);
+
+	res = ui_window_get_res(window);
+	PCUT_ASSERT_NOT_NULL(res);
+
+	gc = ui_window_get_gc(window);
+	PCUT_ASSERT_NOT_NULL(gc);
+
+	ui_window_get_app_rect(window, &rect);
+
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** Test position event callback set via ui_popup_set_cb() */
+PCUT_TEST(send_pos)
+{
+	errno_t rc;
+	ui_t *ui = NULL;
+	ui_popup_params_t params;
+	ui_popup_t *popup = NULL;
+	pos_event_t pos_event;
+	test_cb_resp_t resp;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_popup_params_init(&params);
+
+	rc = ui_popup_create(ui, NULL, &params, &popup);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(popup);
+
+	pos_event.pos_id = 1;
+	pos_event.type = POS_PRESS;
+	pos_event.btn_num = 2;
+	pos_event.hpos = 3;
+	pos_event.vpos = 4;
+
+	/* Pos callback with no callbacks set */
+	ui_window_send_pos(popup->window, &pos_event);
+
+	/* Pos callback with pos callback not implemented */
+	ui_popup_set_cb(popup, &dummy_popup_cb, NULL);
+	ui_window_send_pos(popup->window, &pos_event);
+
+	/* Pos callback with real callback set */
+	resp.pos = false;
+	ui_popup_set_cb(popup, &test_popup_cb, &resp);
+	ui_window_send_pos(popup->window, &pos_event);
+	PCUT_ASSERT_TRUE(resp.pos);
+	PCUT_ASSERT_INT_EQUALS(pos_event.pos_id, resp.pos_event.pos_id);
+	PCUT_ASSERT_EQUALS(pos_event.type, resp.pos_event.type);
+	PCUT_ASSERT_INT_EQUALS(pos_event.btn_num, resp.pos_event.btn_num);
+	PCUT_ASSERT_INT_EQUALS(pos_event.hpos, resp.pos_event.hpos);
+	PCUT_ASSERT_INT_EQUALS(pos_event.vpos, resp.pos_event.vpos);
+
+	ui_popup_destroy(popup);
+	ui_destroy(ui);
+}
+
+static void test_popup_close(ui_popup_t *popup, void *arg)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->close = true;
+}
+
+static void test_popup_kbd(ui_popup_t *popup, void *arg,
+    kbd_event_t *event)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->kbd = true;
+	resp->kbd_event = *event;
+}
+
+static errno_t test_popup_paint(ui_popup_t *popup, void *arg)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->paint = true;
+	return resp->rc;
+}
+
+static void test_popup_pos(ui_popup_t *popup, void *arg,
+    pos_event_t *event)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->pos = true;
+	resp->pos_event = *event;
+}
+
+static errno_t test_ctl_paint(void *arg)
+{
+	test_ctl_resp_t *resp = (test_ctl_resp_t *) arg;
+
+	resp->paint = true;
+	return resp->rc;
+}
+
+static ui_evclaim_t test_ctl_pos_event(void *arg, pos_event_t *event)
+{
+	test_ctl_resp_t *resp = (test_ctl_resp_t *) arg;
+
+	resp->pos = true;
+	resp->pos_event = *event;
+
+	return resp->claim;
+}
+
+static void test_ctl_unfocus(void *arg)
+{
+	test_ctl_resp_t *resp = (test_ctl_resp_t *) arg;
+
+	resp->unfocus = true;
+}
+
+PCUT_EXPORT(popup);
Index: uspace/lib/ui/test/rbutton.c
===================================================================
--- uspace/lib/ui/test/rbutton.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/test/rbutton.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,656 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <gfx/context.h>
+#include <gfx/coord.h>
+#include <mem.h>
+#include <pcut/pcut.h>
+#include <stdbool.h>
+#include <ui/control.h>
+#include <ui/rbutton.h>
+#include <ui/resource.h>
+#include "../private/rbutton.h"
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(rbutton);
+
+static errno_t testgc_set_clip_rect(void *, gfx_rect_t *);
+static errno_t testgc_set_color(void *, gfx_color_t *);
+static errno_t testgc_fill_rect(void *, gfx_rect_t *);
+static errno_t testgc_update(void *);
+static errno_t testgc_bitmap_create(void *, gfx_bitmap_params_t *,
+    gfx_bitmap_alloc_t *, void **);
+static errno_t testgc_bitmap_destroy(void *);
+static errno_t testgc_bitmap_render(void *, gfx_rect_t *, gfx_coord2_t *);
+static errno_t testgc_bitmap_get_alloc(void *, gfx_bitmap_alloc_t *);
+
+static gfx_context_ops_t ops = {
+	.set_clip_rect = testgc_set_clip_rect,
+	.set_color = testgc_set_color,
+	.fill_rect = testgc_fill_rect,
+	.update = testgc_update,
+	.bitmap_create = testgc_bitmap_create,
+	.bitmap_destroy = testgc_bitmap_destroy,
+	.bitmap_render = testgc_bitmap_render,
+	.bitmap_get_alloc = testgc_bitmap_get_alloc
+};
+
+static void test_rbutton_select(ui_rbutton_group_t *, void *, void *);
+
+static ui_rbutton_group_cb_t test_rbutton_group_cb = {
+	.selected = test_rbutton_select
+};
+
+static ui_rbutton_group_cb_t dummy_rbutton_group_cb = {
+};
+
+typedef struct {
+	bool bm_created;
+	bool bm_destroyed;
+	gfx_bitmap_params_t bm_params;
+	void *bm_pixels;
+	gfx_rect_t bm_srect;
+	gfx_coord2_t bm_offs;
+	bool bm_rendered;
+	bool bm_got_alloc;
+} test_gc_t;
+
+typedef struct {
+	test_gc_t *tgc;
+	gfx_bitmap_alloc_t alloc;
+	bool myalloc;
+} testgc_bitmap_t;
+
+typedef struct {
+	bool selected;
+} test_cb_resp_t;
+
+/** Create and destroy radio button */
+PCUT_TEST(create_destroy)
+{
+	ui_rbutton_group_t *group = NULL;
+	ui_rbutton_t *rbutton = NULL;
+	errno_t rc;
+
+	rc = ui_rbutton_group_create(NULL, &group);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_rbutton_create(group, "Hello", NULL, &rbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(rbutton);
+
+	ui_rbutton_destroy(rbutton);
+	ui_rbutton_group_destroy(group);
+}
+
+/** ui_rbutton_destroy() can take NULL argument (no-op) */
+PCUT_TEST(destroy_null)
+{
+	ui_rbutton_destroy(NULL);
+}
+
+/** ui_rbutton_ctl() returns control that has a working virtual destructor */
+PCUT_TEST(ctl)
+{
+	ui_rbutton_group_t *group = NULL;
+	ui_rbutton_t *rbutton;
+	ui_control_t *control;
+	errno_t rc;
+
+	rc = ui_rbutton_group_create(NULL, &group);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_rbutton_create(group, "Hello", NULL, &rbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	control = ui_rbutton_ctl(rbutton);
+	PCUT_ASSERT_NOT_NULL(control);
+
+	ui_control_destroy(control);
+	ui_rbutton_group_destroy(group);
+}
+
+/** Set radio button rectangle sets internal field */
+PCUT_TEST(set_rect)
+{
+	ui_rbutton_group_t *group = NULL;
+	ui_rbutton_t *rbutton;
+	gfx_rect_t rect;
+	errno_t rc;
+
+	rc = ui_rbutton_group_create(NULL, &group);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_rbutton_create(group, "Hello", NULL, &rbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rect.p0.x = 1;
+	rect.p0.y = 2;
+	rect.p1.x = 3;
+	rect.p1.y = 4;
+
+	ui_rbutton_set_rect(rbutton, &rect);
+	PCUT_ASSERT_INT_EQUALS(rect.p0.x, rbutton->rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(rect.p0.y, rbutton->rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(rect.p1.x, rbutton->rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(rect.p1.y, rbutton->rect.p1.y);
+
+	ui_rbutton_destroy(rbutton);
+	ui_rbutton_group_destroy(group);
+}
+
+/** Paint radio button */
+PCUT_TEST(paint)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_rbutton_group_t *group = NULL;
+	ui_resource_t *resource = NULL;
+	ui_rbutton_t *rbutton;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_rbutton_group_create(resource, &group);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_rbutton_create(group, "Hello", NULL, &rbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_rbutton_paint(rbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_rbutton_destroy(rbutton);
+	ui_rbutton_group_destroy(group);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Test ui_rbutton_selected() */
+PCUT_TEST(selected)
+{
+	errno_t rc;
+	ui_rbutton_group_t *group = NULL;
+	ui_rbutton_t *rbutton;
+	test_cb_resp_t resp;
+
+	rc = ui_rbutton_group_create(NULL, &group);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_rbutton_create(group, "Hello", NULL, &rbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Selected with no callbacks set */
+	ui_rbutton_selected(rbutton);
+
+	/* Selected with callback not implementing selected */
+	ui_rbutton_group_set_cb(group, &dummy_rbutton_group_cb, NULL);
+	ui_rbutton_selected(rbutton);
+
+	/* Selected with real callback set */
+	resp.selected = false;
+	ui_rbutton_group_set_cb(group, &test_rbutton_group_cb, &resp);
+	ui_rbutton_selected(rbutton);
+	PCUT_ASSERT_TRUE(resp.selected);
+
+	ui_rbutton_destroy(rbutton);
+	ui_rbutton_group_destroy(group);
+}
+
+/** Press and release radio button */
+PCUT_TEST(press_release)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	ui_rbutton_group_t *group = NULL;
+	ui_rbutton_t *rbutton1;
+	ui_rbutton_t *rbutton2;
+	test_cb_resp_t resp;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_rbutton_group_create(resource, &group);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NULL(group->selected);
+
+	rc = ui_rbutton_create(group, "One", NULL, &rbutton1);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS(group->selected, rbutton1);
+
+	rc = ui_rbutton_create(group, "Two", NULL, &rbutton2);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS(group->selected, rbutton1);
+
+	resp.selected = false;
+	ui_rbutton_group_set_cb(group, &test_rbutton_group_cb, &resp);
+
+	PCUT_ASSERT_FALSE(rbutton2->held);
+	PCUT_ASSERT_FALSE(rbutton2->inside);
+
+	ui_rbutton_press(rbutton2);
+	PCUT_ASSERT_TRUE(rbutton2->held);
+	PCUT_ASSERT_TRUE(rbutton2->inside);
+	PCUT_ASSERT_FALSE(resp.selected);
+	PCUT_ASSERT_EQUALS(group->selected, rbutton1);
+
+	ui_rbutton_release(rbutton2);
+	PCUT_ASSERT_FALSE(rbutton2->held);
+	PCUT_ASSERT_TRUE(rbutton2->inside);
+	PCUT_ASSERT_TRUE(resp.selected);
+	PCUT_ASSERT_EQUALS(group->selected, rbutton2);
+
+	ui_rbutton_destroy(rbutton1);
+	ui_rbutton_destroy(rbutton2);
+	ui_rbutton_group_destroy(group);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Press, leave and release radio button */
+PCUT_TEST(press_leave_release)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	ui_rbutton_group_t *group = NULL;
+	ui_rbutton_t *rbutton1;
+	ui_rbutton_t *rbutton2;
+	test_cb_resp_t resp;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_rbutton_group_create(resource, &group);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NULL(group->selected);
+
+	rc = ui_rbutton_create(group, "One", NULL, &rbutton1);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS(group->selected, rbutton1);
+
+	rc = ui_rbutton_create(group, "Two", NULL, &rbutton2);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS(group->selected, rbutton1);
+
+	resp.selected = false;
+	ui_rbutton_group_set_cb(group, &test_rbutton_group_cb, &resp);
+
+	PCUT_ASSERT_FALSE(rbutton2->held);
+	PCUT_ASSERT_FALSE(rbutton2->inside);
+
+	ui_rbutton_press(rbutton2);
+	PCUT_ASSERT_TRUE(rbutton2->held);
+	PCUT_ASSERT_TRUE(rbutton2->inside);
+	PCUT_ASSERT_FALSE(resp.selected);
+	PCUT_ASSERT_EQUALS(group->selected, rbutton1);
+
+	ui_rbutton_leave(rbutton2);
+	PCUT_ASSERT_TRUE(rbutton2->held);
+	PCUT_ASSERT_FALSE(rbutton2->inside);
+	PCUT_ASSERT_FALSE(resp.selected);
+	PCUT_ASSERT_EQUALS(group->selected, rbutton1);
+
+	ui_rbutton_release(rbutton2);
+	PCUT_ASSERT_FALSE(rbutton2->held);
+	PCUT_ASSERT_FALSE(rbutton2->inside);
+	PCUT_ASSERT_FALSE(resp.selected);
+	PCUT_ASSERT_EQUALS(group->selected, rbutton1);
+
+	ui_rbutton_destroy(rbutton1);
+	ui_rbutton_destroy(rbutton2);
+	ui_rbutton_group_destroy(group);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Press, leave, enter and release radio button */
+PCUT_TEST(press_leave_enter_release)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	ui_rbutton_group_t *group = NULL;
+	ui_rbutton_t *rbutton1;
+	ui_rbutton_t *rbutton2;
+	test_cb_resp_t resp;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_rbutton_group_create(resource, &group);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NULL(group->selected);
+
+	rc = ui_rbutton_create(group, "One", NULL, &rbutton1);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS(group->selected, rbutton1);
+
+	rc = ui_rbutton_create(group, "Two", NULL, &rbutton2);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS(group->selected, rbutton1);
+
+	resp.selected = false;
+	ui_rbutton_group_set_cb(group, &test_rbutton_group_cb, &resp);
+
+	PCUT_ASSERT_FALSE(rbutton2->held);
+	PCUT_ASSERT_FALSE(rbutton2->inside);
+
+	ui_rbutton_press(rbutton2);
+	PCUT_ASSERT_TRUE(rbutton2->held);
+	PCUT_ASSERT_TRUE(rbutton2->inside);
+	PCUT_ASSERT_FALSE(resp.selected);
+	PCUT_ASSERT_EQUALS(group->selected, rbutton1);
+
+	ui_rbutton_leave(rbutton2);
+	PCUT_ASSERT_TRUE(rbutton2->held);
+	PCUT_ASSERT_FALSE(rbutton2->inside);
+	PCUT_ASSERT_FALSE(resp.selected);
+	PCUT_ASSERT_EQUALS(group->selected, rbutton1);
+
+	ui_rbutton_enter(rbutton2);
+	PCUT_ASSERT_TRUE(rbutton2->held);
+	PCUT_ASSERT_TRUE(rbutton2->inside);
+	PCUT_ASSERT_FALSE(resp.selected);
+	PCUT_ASSERT_EQUALS(group->selected, rbutton1);
+
+	ui_rbutton_release(rbutton2);
+	PCUT_ASSERT_FALSE(rbutton2->held);
+	PCUT_ASSERT_TRUE(rbutton2->inside);
+	PCUT_ASSERT_TRUE(resp.selected);
+	PCUT_ASSERT_EQUALS(group->selected, rbutton2);
+
+	ui_rbutton_destroy(rbutton1);
+	ui_rbutton_destroy(rbutton2);
+	ui_rbutton_group_destroy(group);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** ui_pos_event() correctly translates POS_PRESS/POS_RELEASE */
+PCUT_TEST(pos_event_press_release)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	ui_rbutton_group_t *group = NULL;
+	ui_rbutton_t *rbutton;
+	ui_evclaim_t claim;
+	pos_event_t event;
+	gfx_rect_t rect;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_rbutton_group_create(resource, &group);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_rbutton_create(group, "Hello", NULL, &rbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_FALSE(rbutton->held);
+
+	rect.p0.x = 10;
+	rect.p0.y = 20;
+	rect.p1.x = 30;
+	rect.p1.y = 40;
+	ui_rbutton_set_rect(rbutton, &rect);
+
+	/* Press outside is not claimed and does nothing */
+	event.type = POS_PRESS;
+	event.hpos = 9;
+	event.vpos = 20;
+	claim = ui_rbutton_pos_event(rbutton, &event);
+	PCUT_ASSERT_FALSE(rbutton->held);
+	PCUT_ASSERT_EQUALS(ui_unclaimed, claim);
+
+	/* Press inside is claimed and depresses radio button */
+	event.type = POS_PRESS;
+	event.hpos = 10;
+	event.vpos = 20;
+	claim = ui_rbutton_pos_event(rbutton, &event);
+	PCUT_ASSERT_TRUE(rbutton->held);
+	PCUT_ASSERT_EQUALS(ui_claimed, claim);
+
+	/* Release outside (or anywhere) is claimed and relases radio button */
+	event.type = POS_RELEASE;
+	event.hpos = 9;
+	event.vpos = 20;
+	claim = ui_rbutton_pos_event(rbutton, &event);
+	PCUT_ASSERT_FALSE(rbutton->held);
+	PCUT_ASSERT_EQUALS(ui_claimed, claim);
+
+	ui_rbutton_destroy(rbutton);
+	ui_rbutton_group_destroy(group);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** ui_pos_event() correctly translates POS_UPDATE to enter/leave */
+PCUT_TEST(pos_event_enter_leave)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	ui_rbutton_group_t *group = NULL;
+	ui_rbutton_t *rbutton;
+	pos_event_t event;
+	gfx_rect_t rect;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_rbutton_group_create(resource, &group);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_rbutton_create(group, "Hello", NULL, &rbutton);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_FALSE(rbutton->inside);
+
+	rect.p0.x = 10;
+	rect.p0.y = 20;
+	rect.p1.x = 30;
+	rect.p1.y = 40;
+	ui_rbutton_set_rect(rbutton, &rect);
+
+	/* Moving outside does nothing */
+	event.type = POS_UPDATE;
+	event.hpos = 9;
+	event.vpos = 20;
+	ui_rbutton_pos_event(rbutton, &event);
+	PCUT_ASSERT_FALSE(rbutton->inside);
+
+	/* Moving inside sets inside flag */
+	event.type = POS_UPDATE;
+	event.hpos = 10;
+	event.vpos = 20;
+	ui_rbutton_pos_event(rbutton, &event);
+	PCUT_ASSERT_TRUE(rbutton->inside);
+
+	/* Moving outside clears inside flag */
+	event.type = POS_UPDATE;
+	event.hpos = 9;
+	event.vpos = 20;
+	ui_rbutton_pos_event(rbutton, &event);
+	PCUT_ASSERT_FALSE(rbutton->inside);
+
+	ui_rbutton_destroy(rbutton);
+	ui_rbutton_group_destroy(group);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+static errno_t testgc_set_clip_rect(void *arg, gfx_rect_t *rect)
+{
+	(void) arg;
+	(void) rect;
+	return EOK;
+}
+
+static errno_t testgc_set_color(void *arg, gfx_color_t *color)
+{
+	(void) arg;
+	(void) color;
+	return EOK;
+}
+
+static errno_t testgc_fill_rect(void *arg, gfx_rect_t *rect)
+{
+	(void) arg;
+	(void) rect;
+	return EOK;
+}
+
+static errno_t testgc_update(void *arg)
+{
+	(void) arg;
+	return EOK;
+}
+
+static errno_t testgc_bitmap_create(void *arg, gfx_bitmap_params_t *params,
+    gfx_bitmap_alloc_t *alloc, void **rbm)
+{
+	test_gc_t *tgc = (test_gc_t *) arg;
+	testgc_bitmap_t *tbm;
+
+	tbm = calloc(1, sizeof(testgc_bitmap_t));
+	if (tbm == NULL)
+		return ENOMEM;
+
+	if (alloc == NULL) {
+		tbm->alloc.pitch = (params->rect.p1.x - params->rect.p0.x) *
+		    sizeof(uint32_t);
+		tbm->alloc.off0 = 0;
+		tbm->alloc.pixels = calloc(sizeof(uint32_t),
+		    (params->rect.p1.x - params->rect.p0.x) *
+		    (params->rect.p1.y - params->rect.p0.y));
+		tbm->myalloc = true;
+		if (tbm->alloc.pixels == NULL) {
+			free(tbm);
+			return ENOMEM;
+		}
+	} else {
+		tbm->alloc = *alloc;
+	}
+
+	tbm->tgc = tgc;
+	tgc->bm_created = true;
+	tgc->bm_params = *params;
+	tgc->bm_pixels = tbm->alloc.pixels;
+	*rbm = (void *)tbm;
+	return EOK;
+}
+
+static errno_t testgc_bitmap_destroy(void *bm)
+{
+	testgc_bitmap_t *tbm = (testgc_bitmap_t *)bm;
+	if (tbm->myalloc)
+		free(tbm->alloc.pixels);
+	tbm->tgc->bm_destroyed = true;
+	free(tbm);
+	return EOK;
+}
+
+static errno_t testgc_bitmap_render(void *bm, gfx_rect_t *srect,
+    gfx_coord2_t *offs)
+{
+	testgc_bitmap_t *tbm = (testgc_bitmap_t *)bm;
+	tbm->tgc->bm_rendered = true;
+	tbm->tgc->bm_srect = *srect;
+	tbm->tgc->bm_offs = *offs;
+	return EOK;
+}
+
+static errno_t testgc_bitmap_get_alloc(void *bm, gfx_bitmap_alloc_t *alloc)
+{
+	testgc_bitmap_t *tbm = (testgc_bitmap_t *)bm;
+	*alloc = tbm->alloc;
+	tbm->tgc->bm_got_alloc = true;
+	return EOK;
+}
+
+static void test_rbutton_select(ui_rbutton_group_t *group, void *arg,
+    void *barg)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->selected = true;
+}
+
+PCUT_EXPORT(rbutton);
Index: uspace/lib/ui/test/resource.c
===================================================================
--- uspace/lib/ui/test/resource.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/test/resource.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -44,4 +44,6 @@
 static errno_t testgc_bitmap_get_alloc(void *, gfx_bitmap_alloc_t *);
 
+static void test_expose(void *);
+
 static gfx_context_ops_t ops = {
 	.bitmap_create = testgc_bitmap_create,
@@ -68,4 +70,8 @@
 } testgc_bitmap_t;
 
+typedef struct {
+	bool expose;
+} test_resp_t;
+
 /** Create and destroy UI resource */
 PCUT_TEST(create_destroy)
@@ -80,5 +86,5 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
-	rc = ui_resource_create(gc, &resource);
+	rc = ui_resource_create(gc, false, &resource);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(resource);
@@ -97,4 +103,33 @@
 {
 	ui_resource_destroy(NULL);
+}
+
+/** ui_resource_set_expose_cb() / ui_resource_expose() */
+PCUT_TEST(set_expose_cb_expose)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	test_resp_t resp;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	ui_resource_set_expose_cb(resource, test_expose, &resp);
+
+	resp.expose = false;
+	ui_resource_expose(resource);
+	PCUT_ASSERT_TRUE(resp.expose);
+
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 }
 
@@ -161,3 +196,10 @@
 }
 
+static void test_expose(void *arg)
+{
+	test_resp_t *resp = (test_resp_t *) arg;
+
+	resp->expose = true;
+}
+
 PCUT_EXPORT(resource);
